import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Maus here.
 * 
 * @author (Claudia Knorr) 
 * @version (03/2011)
 */
public class Maus  extends Beweglich
{
    /**
     * In dieser Mehtode wird alles beschrieben, was die Maus "tun" kann.
     * Sie wird aktiviert, wenn der act-Button gedrckt wird.
     * Methoden mit dem Rckgabewert void stellen Befehle dar.
     * Der Befehl bewegDich () ist in der Klasse Beweglich definiert
     */
    public void act() 
    {
       schauNachElefant();
       bewegDich();
       schauNachWeltRand();
       schauNachWasserloch();
       schauNachElefantenfalle();
    }    
   /**
    * Wenn sich die Maus mit dem Elefant "berschneidet" bzw. ihn berhrt wird der
    * Elefant aus der Welt entfertn. Und das Spiel wird gestoppt. 
    */
    
    public void schauNachElefant ()
    {
        if (schauNach(Elefant.class))
        { esseIhn(Elefant.class);
          Greenfoot.playSound("ohNo.wav");
          getWorld().addObject (new VerlorenMaus(), 257, 222);
          Greenfoot.stop();
        }
    }
    /**
     * Der Rckgabewert fr boolean ist entweder true oder false (wahr oder falsch) != bedeutet ungleich Null 
     */
    public boolean schauNach(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }
    /**
     * Entfernt ein Objekt aus der Welt
     */
    public void esseIhn(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if(actor != null) {
            getWorld().removeObject(actor);
        }
    }
  /**
   * Die Maus kann weder durch das Wasserloch noch die Elefantenfalle "gehen". Sie dreht
   * sich bei beiden Objekten. 
   */
    
    
    public void schauNachWasserloch()
{
    if (schauNach(Wasserloch.class)){
        turn(45);
    }
   
}
 public void schauNachElefantenfalle()
{
    if (schauNach(Elefantenfalle.class)){
        turn(45);
    }
}
}


