import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * Alle Methoden ungleich void Stellen Fragen dar
 * Rckgabetypen fr Methoden
 * void liefert keinen Wert zurck (Stellt einen Befehl dar)
 * int liefert ganze Zahlen zurck 
 * boolean liefert entweder true (wahr) oder false (falsch) zurck
 * 
 */
public class Elefant extends Beweglich
{
    
    private GreenfootImage image1;
    private GreenfootImage image2;
    private int gegessen;
    private int zaehlerBildaendern;
    
    public Elefant()
    {
        
        image1=new GreenfootImage("elephant.png");
        image2=new GreenfootImage("elephant2.png");
        setImage(image1);
        gegessen = 0;
        zaehlerBildaendern=0;
    }
      
    public void act() 
    {
        aendereBild();
        steuerung ();
        schauWasserloch();
        schauNachEssen();    
        zaehlerBildaendern=zaehlerBildaendern+1;
     }
     /**
      * In der Act - Methode wurde ein Zhler eingegaut, und wenn dieser Zhler
      * die 8 erreicht wird er wieder auf Null gesetzt und der Elefant ndert das 
      * Bild
      */
     public void aendereBild()
    {
        if(zaehlerBildaendern==8)
        {
        zaehlerBildaendern=0;
    
        if (getImage() == image1) 
        {
            setImage(image2);
        }
        else
        {
            setImage(image1);
        }
        }
}
/**
 * Hier werden die Befehle gegeben, wenn die Pfeiltaste nach "links" gedrckt wird
 * schaue nach links, bewege dich nach links und zwar mit der Geschwindigkeit 10. Das Bild fr "schau nach links" ist in der Klasse "Beweglich" hinterlegt
 */  

  public void steuerung ()
    {
     if (Greenfoot.isKeyDown("left") )
        {
            lookToTheLeft();
            moveLeft();
            setSpeed(10);
        }
         if (Greenfoot.isKeyDown("right") )
        {
            lookToTheRight();
            moveRight();
            setSpeed(10);
        }
        if (Greenfoot.isKeyDown("up") )
        {
            moveUp();
            setSpeed(10);
        }
        if (Greenfoot.isKeyDown("down") )
        {
            moveDown();
            setSpeed(10);
        } 

    }
    /**
     * Wenn der Elefant auf die Klasse Essen mit den Objekten Bananen und Muffins 
     * trifft, isst er diese (sie werden aus der Welt entfernt), es ertnt ein 
     * Gerusch und die "gegessenen" Objekte werden gezhlt.
     * Fr jedes gegessene Essen wird ein Punkt hinzugezhlt.
     * Bei 10 gegessenen Objekte ertnt ein Gerusch und der Elefant kommt ins 
     * nchste Level. Quelle fr Elefantengerusch: http://www.ringelkater.de/Sounds/s_2geraeusche22.htm
     */
    
    
    public void schauNachEssen ()
      {
        if (schauNach(Essen.class))
        { esseEs(Essen.class);
          Greenfoot.playSound("slurp.wav");
         gegessen = gegessen +1;
         punkteUp();
        if (gegessen == 10)
        {  
          Sahara sahara =(Sahara) getWorld();
          sahara.addLevel();
          Greenfoot.playSound("elefant.wav");
         
         
        }
       
       }
    }
    public boolean schauNachWasserloch(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0,-12, clss);
        return actor != null; 
    }
   
    public boolean schauNach(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }
    /**
     * Wenn der Elefant das Wasserloch berhrt, wird seine Geschwindgkeit reduziert (man luft im Wasser auch langsamer).
     */
      public void schauWasserloch()
    {
        Actor stein = getOneIntersectingObject(Wasserloch.class);
        if (schauNach(Wasserloch.class))
        { 
        setSpeed(1);
        
        }
    }
    
    public void esseEs(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if(actor != null) {
            getWorld().removeObject(actor);
        }
    }
    /**
     * Hier werden die gezhlen Punkte an die Welt Sahara weitergegeben
     */
    public void punkteUp()
    { 
                ((Sahara)getWorld()).punkteUp();            
     }
        }
