import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * In dieser Welt befinden sich 3 Level
 * 
 * @author (Claudia Knorr) 
 * @version (03/2011)
 */
public class Sahara  extends World
{
   
  public int level;
  public int punkte;


    /**
     * Konstuiert eine Welt mit einem Hindergrund (Backround) und den Objekten
     * und Startbutton (Startbildschirm)
     * 
     */
    public Sahara()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
       super(600,500, 1); 
        
        addObject (new Anleitung(),309,201);
        addObject (new Start(),279,450);
        } 
    /**
     * Hier Startet das Spiel in der ersten Welt (Level 1) 
     */
       public void levelOne()
    {
        
         level=1; 
        
        
   
     GreenfootImage image = this.getBackground();
      
                      
      
       image.setColor(Color.LIGHT_GRAY);
       image.drawRect(15, 30, 90, 50); 
       image.fillRect(15, 30, 90, 50); 
       
       image.setColor(Color.darkGray);
       image.drawString("Level:     " + level, 30, 50);
       image.drawString("Punkte:  " + punkte, 30, 70);
        
        removeObjects(getObjects(Actor.class)); //entfernt das Object aus der WElt
        
        addObject (new Wasserloch(),489,48);    
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
       
        
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        
        addObject (new Maus(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Elefant(),276,366);
        
    }
    public void levelTwo()

{
             
        
        level=2;      

   
        removeObjects(getObjects(Actor.class));
       
        addObject (new Wasserloch(),489,48);
        addObject (new Wasserloch(),106,451);
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
       
        
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        
        addObject (new Maus(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Maus(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Elefant(),276,366);
        addObject (new Elefantenfalle(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Elefantenfalle(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
   
    }
public void levelThree()
    {
         
        
        level=3;      

        removeObjects(getObjects(Actor.class));
        addObject (new Wasserloch(),471,74);    
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Muffin(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
       
        
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Bananen(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        
        addObject (new Maus(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Maus(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        
        addObject (new Elefant(),276,366);
        
        addObject (new Elefantenfalle(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Elefantenfalle(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Elefantenfalle(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
        addObject (new Elefantenfalle(),Greenfoot.getRandomNumber(600),Greenfoot.getRandomNumber(500));
    }
  
    public void addLevel()
    {
        level++;
       
        if(level == 1) levelOne();
        if(level == 2) levelTwo();
        if(level == 3) levelThree();
        if(level == 4) gameFinished();
        
        
        
        
        
    }
   public int getLevel()
    {
        return level;
    }
    /**
     * Wenn levelUp aufgerufen wir, wird an dieser stelle 1 dazugezhlt und man kommt somit ins nchste Level
     */
 
    public void levelUp()
    {
         level=level +1;
       
       
   
     }
     
    public void punkte()
    {
        punkte=0;
    }
    public void level()
    {
        level=0;
    }
   /**
    * Wenn punkteUp aufgerufen wird, wird zu der bisherigen Punktzahl 1 dazu gezhlt. An diser Stelle befindet sich der "Level und Punkte zhler"
    */
    public void punkteUp()
   {
       punkte=punkte +1;
        
                      
       GreenfootImage image = this.getBackground();
       image.setColor(Color.LIGHT_GRAY);
       image.drawRect(15, 30, 90, 50); 
       image.fillRect(15, 30, 90, 50); 
       
       image.setColor(Color.darkGray);
       image.drawString("Level:     " + level, 30, 50);
       image.drawString("Punkte:  " + punkte, 30, 70);
      
    }
   
     
 
    
    public void gameFinished()
    {
        removeObjects(getObjects(Actor.class));
        addObject (new Gewonnen(),273,321);
         Greenfoot.playSound("hooray.wav");
        Greenfoot.stop();
        

        }
    }